// Copyright (C) 2010 - Ievgen IVANOV
// Copyright (C) 2010 - Allan CORNET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

ilib_verbose(2);

XcosCtl_names = ["hybm_xcosOpenBlock" , "sci_xcosOpenBlock"   ;
        "hybm_xcosHDF5ToDiagram"   , "sci_xcosHDF5ToDiagram"      ];


XcosCtl_files = ["sci_xcosOpenBlock.cpp" ;
        "sci_xcosHDF5ToDiagram.cpp"    ;
        "XcosControl.cpp"        ;
        "GiwsException.cpp"        ];

XcosCtl_gateway_path = get_absolute_file_path("builder_gateway_cpp.sce");

java_home = getenv("JAVA_HOME","");

//use function getos() from SEP 39
if (getos()=="Windows") then
  if java_home == "" then
    // local build
    local_jdk = SCI+"/java/jdk";
    if isdir(local_jdk) then
     cflags = '-I'+local_jdk+"\include"+" -I"+local_jdk+"\include\win32";
    else
    error("JDK not found. Please define JAVA_HOME environnment variable.")
    end
  else
    cflags = '-I'+java_home+"\include"+" -I"+java_home+"\include\win32";
  end
elseif (getos()=="Linux") then
  if java_home <> "" then
    cflags = "-I"+java_home+"/include"+" -I"+java_home+"include/linux";
  else
    error("JDK not found. Please define JAVA_HOME environnment variable.")
  end
else
  if (getos()=="Darwin") then
    macos_java_home = "/System/Library/Frameworks/JavaVM.framework/Versions/CurrentJDK/Home";
    if isdir(macos_java_home) & java_home == "" then
      java_home = macos_java_home;
    end
    if java_home <> "" then
      cflags = "-I" + java_home + "/include";
    else
      error("JDK not found. Please define JAVA_HOME environnment variable.")
    end
  else
    if java_home <> "" then
      cflags = "-I"+java_home+"/include";
    else
      error("JDK not found. Please define JAVA_HOME environnment variable.")
    end
  end
end

if (getos()<>"Windows") then

  cflags = cflags + " -I" + XcosCtl_gateway_path;
  // Source tree version
  if isdir(SCI+"/modules/core/includes/") then
    cflags = cflags + " -I"+SCI+"/modules/jvm/includes/";
  end

  // Binary version
  if isdir(SCI+"/../../include/scilab/core/") then
     cflags = cflags + " -I" + SCI + "/../../include/scilab/jvm/";
  end

  // System version (ie: /usr/include/scilab/)
  if isdir("/usr/include/scilab/") then
    cflags = cflags + " -I/usr/include/scilab/jvm/";
  end
end

tbx_build_gateway("XcosCtl",..
          XcosCtl_names,..
          XcosCtl_files,..
          XcosCtl_gateway_path,..
          [],..
          "",..
          cflags);

clear tbx_build_gateway;


